clear all; close all;
%function [] = globecom_DF(bat_iter)
rand('state',41); rng('default');
load('data1.mat');
load('spar.mat');
load('greedy.mat');
% BS_Power2 = BS_Power;
% delta2 = delta;
nUE = 4;
time = 100;
E_max = 200;
index_cnt=1;
for k=1:time
    EBU1_1min(k) =E_max*rand(1,1);
end
EBU1_PV_Output = EBU1_1min;
UE_distance = 100*rand(nUE,1)+50*ones(nUE,1); % 50m
for iter = 1
P_min = 35;
P_max = 140;
user_weight = 1;
c_effi = 0.8; % charging efficiency
s_effi = 0.99; % storage efficiency

bat_capacity = 250; %100 WHr
penalty = 30*iter;
theta_bat = penalty + P_max;

UE_buffermax = 500*ones(nUE); %500M 

macro_power = 5.2;
noise = -105.86;
carrier_num = 5;
delta_max = 10; % the max buffer consumption rate is 10M
UE_theta = user_weight*penalty + delta_max;

radius = 1000;%1km
grid_ = zeros(time,1); % grid power consumption
discharge = zeros(time,1);
cost = zeros(time,1);
BS_Power = zeros(time,1);
utility = zeros(nUE,time);
delta = zeros(nUE,time);

UE_SINR = zeros(nUE,carrier_num);
UE_avg_SINR = zeros(nUE,1);
UE_rate = zeros(nUE,1);
UE_buffer = zeros(nUE,time);
battery = zeros(time,1);

for nUE_loop = 1 :nUE % initialization
    
        UE_buffer(nUE_loop,1) = 10;
        for k = 1: carrier_num
            UE_SINR (nUE_loop,k) = 0;
            UE_rate (nUE_loop,k) = 0;
        end
        UE_avg_SINR(nUE_loop) = 10^(0.1*(macro_power - noise - 140.1 - 36.7 * log10(UE_distance(nUE_loop)/radius )));
end
channel_exhau = 5^carrier_num;
energy_exhau = 340;
%coding for exhaustive
for t = 1:time
    for x = 1: channel_exhau
        for y = 1:energy_exhau
            exhau_index()
        end
    end
end



for t = 1:time
    for x = 1: channel_exhau
        for y = 1:energy_exhau
    
            charge = y - energy_exhau; 
            if charge > EBU1_PV_Output(t)
                continue;
            end
            if t>1
                battery(t,:) = battery(t-1);         
            end

            for nUE_loop = 1 :nUE
                if t>1
                    UE_buffer(nUE_loop,t) = UE_buffer(nUE_loop,t-1);
                end
                    utility(nUE_loop,t) = log(1+mean_delta(nUE_loop,iter));
                for k = 1: carrier_num
                    UE_SINR (nUE_loop,k)  = exprnd(UE_avg_SINR(nUE_loop));
                    UE_rate(nUE_loop,k) = log2(1+UE_SINR(nUE_loop,k))*10/carrier_num;
           % pathloss = 128.1 + 37.6 log10(R)dB (R [km])
                end
           end
    % UE_buffer_queue = UE_buffer(:,t) - UE_theta*ones(nUE,1);
        req_rate = zeros(nUE,1);
        for k = 1: carrier_num
                if mod(x,5) = 0
                    x = x/5;
                    continue;
                end
                req_rate(mod(x,10^k)) = req_rate(mod(x,10^k)) + UE_rate(mod(x,10^k),k);
                x=x/5;
        end
    %check if rate requirement satisfied    
        check = true;
        for nUE_loop = 1 :nUE
            if  req_rate(nUE_loop)<mean_delta(index_buf(nUE_loop),iter)
                check = false;
                break;
            end
        end
     if check = false
         continue;
     end


    UE_buffer(:,t) =  UE_buffer(:,t) + - mean_delta(:,iter);
    
BS_Power(t) = P_min + (P_max-P_min)*sum(active)/carrier_num;
switch use_bat
    case 1
        battery(t) = battery(t)*s_effi - max(BS_Power(t)-EBU1_PV_Output(t),0) ;
        grid_(t) =0;

    case -1
        battery(t) = min(battery(t) *s_effi + EBU1_PV_Output(t)*c_effi,bat_capacity); 
        grid_(t) =BS_Power(t);
end
cost(t) = grid_(t) -user_weight* sum(utility(:,t));
agg_util = sum(utility(:,t));
end
        end
    end







buffer_perf_max(iter) = max(max(UE_buffer));
battery_perf_max(iter) = max(battery);
buffer_perf(iter) =mean(mean(UE_buffer,2));
cost_perf(iter)=mean(cost)
util_perf(iter)=mean(agg_util)
grid_perf(iter)=mean(grid_)
battery_perf(iter)=mean(battery)


cost_greedy(iter) = greedy_cost ;
battery_greedy(iter) = greedy_battery;
buffer_greedy(iter) = greedy_buffer;
buffer_greedy_max(iter) = greedy_buffer_max;
battery_greedy_max(iter) = greedy_battery_max;
end
buffer_perf_max(iter) = max(max(UE_buffer))
battery_perf_max(iter) = max(battery)
buffer_perf(iter) =mean(mean(UE_buffer,2))
cost_perf(iter)=mean(cost)
util_perf(iter)=mean(agg_util)
grid_perf(iter)=mean(grid_)
battery_perf(iter)=mean(battery)

fig =figure
box on;
hold on;

plot(cost_greedy,'-b*','linewidth',2);
plot (cost_perf,'-g+','linewidth',2);
plot (cost_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')

legend('Greedy-MP','LPB','L-SPAR','FontSize')

set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
ylabel('Weighted Sum of Energy Consumption and Utility','FontSize',12,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'Network_versus_V';
saveas(gcf, fig_name,'emf');
saveas(gcf, fig_name, 'fig');



fig =figure
box on;

hold on
plot (util_spar,'-g+','linewidth',2);
plot (util_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Aggregate Utility','FontSize',14,'fontWeight','bold')
legend('LPB','L-SPAR','FontSize')
axis([1 8 0 25])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'utility_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

fig =figure
box on
hold on

plot (grid_perf,'-g+','linewidth',2);
plot (grid_spar,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Average Grid Power Consumption(W)','FontSize',14,'fontWeight','bold')
legend('LPB','L-SPAR')
axis([1 8 0 80])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'energy_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

fig =figure
box on
hold on

plot(battery_greedy_max,'-b*','linewidth',2);
plot (battery_perf_max,'-g+','linewidth',2);
plot (battery_spar_max,'-ro','linewidth',2);
xlabel('V','FontSize',14)
ylabel('Required Battery(J)','FontSize',14,'fontWeight','bold')
legend('Greedy-MP','LPB','L-SPAR')
axis([1 8 0 400])
set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;
print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'Max Bat_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');


fig =figure
box on
hold on

plot(buffer_greedy_max,'-b*','linewidth',2);
plot (buffer_perf,'-g+','linewidth',2);
plot (buffer_spar_max,'-ro','linewidth',2);
xlabel('V','FontSize',14,'fontWeight','bold')
ylabel('Required Buffer(MB)','FontSize',14,'fontWeight','bold')
legend('Greedy-MP','LPB','L-SPAR','FontSize')

set(findall(fig, '-property', 'FontSize'), 'FontSize', 14,'fontWeight','bold')
set(gca,'XTick',1:9)
set(gca,'XTickLabel',{'30','60','90','120','150','180','210','240','270'})
print Vdmeta;

print (fig,'-dmeta','-painters','-r864','dataFigure');
fig_name = 'max_buffer_versus_V';
saveas(gcf, fig_name, 'emf');
saveas(gcf, fig_name, 'fig');

%  mean(BS_Power)